var EpgShort = {
	page : 0,
	on_page : 13,
	list : [],
	num : 0,
	servertime : 0,
}

EpgShort.Init = function()
{	
	EpgShort.SetDeactive();
	var tv_id = TV.getChId();
	this.num = tv_id % this.on_page;
	this.page = (tv_id - this.num) / this.on_page;
	EpgShort.UpdateList();
}

EpgShort.Loading = function()
{
	for (var i = 0; i < this.on_page; i++)
		byID("epgs_pr" + i).innerHTML = "";
	byID("epgs_pr0").innerHTML = "загрузка данных ...";	
	
}

EpgShort.GetList = function()
{
	EpgShort.Loading();
	for (var i = 0; i < this.on_page; i++)
	{
		this.list[i] = new Array;
		var j = i + this.page*this.on_page;
		if (j < TV.programs_count)
		{
			byID("epgs_img" + i).src = Main.baseImgURL + TV.ch_list[j].logo_big;
			byID("epgs_name" + i).innerHTML = TV.ch_list[j].num + "." + TV.ch_list[j].name.substr(0,17);

		$.ajax(
		 {
			 type:   'GET',
			 url:    Main.baseReqURL + 'epg.php',
			 data:   "ignoreGmt=y&cid=" + TV.ch_list[j].id + "&day=" + Epg.DDMMYY(Main.servertime) + "&" + Main.sid_name + "=" + Main.sid,
			 success: (function(i){return function(data) { 
						var temp_list = data;
						var start_id = 0;
						EpgShort.servertime = temp_list.servertime;
						alert(temp_list.epg.length);
						for (var k = 0; k < temp_list.epg.length; k++)
							if (temp_list.epg[k].ut_start > EpgShort.servertime) { start_id = k; break;}
							
						alert("start_id = " + start_id);
						
						if (start_id > EpgShort.on_page/2)
						{
							for (var k = 0; k < EpgShort.on_page; k++)
							{
								var l = k + start_id - Math.ceil(EpgShort.on_page/2);
								if (l < temp_list.epg.length)
									EpgShort.list[i][k] = temp_list.epg[l];					
							}						
						
						}else{
							for (var k = 0; k < EpgShort.on_page; k++)
							{
								if (k < temp_list.epg.length)
									EpgShort.list[i][k] = temp_list.epg[k];					
							}
						}
						if ( i == EpgShort.num ) EpgShort.ShowEpgForCh();
				} })(i),
			 error:   function() { },
		 });
			

		}else{
			byID("epgs_img" + i).src = "";
			byID("epgs_name" + i).innerHTML = "";
		}
	}

}

EpgShort.UpdateList = function()
{
	EpgShort.GetList();
	EpgShort.SetActive();

}

EpgShort.ShowEpgForCh = function()
{
	
	var flag = true;
	alert("ShowEpgForCh " + this.list[this.num].length);
	for (var i = 0; i < this.on_page; i++)	
	{	
		if (i < this.list[this.num].length)
		{
			byID("epgs_pr" + i).className = "";
			widgetAPI.putInnerHTML(byID("epgs_pr" + i), this.list[this.num][i].t_start + ' ' + this.list[this.num][i].progname.substr(0,70));
			if (this.list[this.num][i].ut_start < this.servertime)
				byID("epgs_pr" + i).className = "archive"; 
			if ( ((i+1 == this.list[this.num].length) && flag) || flag && (this.list[this.num][i+1].ut_start > this.servertime))
			{
				flag = false;
				byID("epgs_pr" + i).className = "current"; 
			}
		}else{
			widgetAPI.putInnerHTML(byID("epgs_pr" + i), "");
		}
	}

}

EpgShort.SetActive = function()
{
	byID("epgs_name" + this.num).className = "active";
}

EpgShort.SetDeactive = function()
{
	byID("epgs_name" + this.num).className = "";
}

EpgShort.KeyLeft = function()
{
	EpgShort.SetDeactive();
	if (this.page > 0)
	{
		this.page--;		
	}else{	
		this.num = TV.programs_count%this.on_page;
		this.page = (TV.programs_count - this.num)/this.on_page - 1;
	}
	EpgShort.UpdateList();
	EpgShort.SetActive();
}

EpgShort.KeyRight = function()
{
	EpgShort.SetDeactive();
	var max_page = (TV.programs_count - TV.programs_count%this.on_page)/this.on_page - 1;
	if (this.page < max_page)
	{
		this.page++;		
	}else{			
		this.page = 0;
	}
	EpgShort.UpdateList();
	EpgShort.SetActive();
}

EpgShort.KeyUp = function()
{
	EpgShort.SetDeactive();
	if (this.num > 0)
	{
		this.num--;
		EpgShort.ShowEpgForCh();
	}else{	
		if (this.page == 0)
		{
			this.num = TV.programs_count%this.on_page;
			this.page = (TV.programs_count - this.num)/this.on_page - 1;
		}else{
			this.page--;
			this.num = this.on_page - 1;
		}
		EpgShort.UpdateList();
	}
	EpgShort.SetActive();
	
}

EpgShort.KeyDown = function()
{
	var t = this.num + this.on_page*this.page;
	EpgShort.SetDeactive();
	if (t < TV.programs_count - 1)
	{
		if (this.num < this.on_page - 1)
		{
			this.num++;
			EpgShort.ShowEpgForCh();
		}else{
			this.num = 0;
			this.page++;
			EpgShort.UpdateList();
		}
	}else{	
		this.num = 0;
		this.page = 0;
		EpgShort.UpdateList();
	}
	EpgShort.SetActive();
}

EpgShort.KeyEnter = function()
{
	
	Epg.channel = TV.ch_list[this.num + this.page*this.on_page];
	Epg.Init();
	Main.ChangeScreen("epg");
	//TV.ch_id = this.num + this.page*this.on_page;
	//TV.PlayChannel();
}

EpgShort.MainKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
		case tvKey.KEY_LEFT :
			EpgShort.KeyLeft();
			break;
		case tvKey.KEY_RIGHT :
			EpgShort.KeyRight();
			break;
		case tvKey.KEY_UP :			
			EpgShort.KeyUp();
			break;
		case tvKey.KEY_DOWN :			
			EpgShort.KeyDown();
			break;
		case tvKey.KEY_ENTER :			
		case tvKey.KEY_RED :
			EpgShort.KeyEnter();
			break;	
        case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);			
			(Player.stopped) ? Main.ChangeScreen(Main.backscreen) : Main.ChangeScreen("player");
		break;
	}
}