var Menu = {
	main_menu : ["tv", "epgshort", "vod", "settings", "info", "help", "exit"],
	main_menu_id : 0,
	days : ["воскресенье", "понедельник", "вторник", "среда", "четверг", "пятница", "суббота"],
	month : ["января", "февраля", "марта", "апреля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря"]
}

Menu.DeactiveIco = function(i)
{
	byID('ms' + i).src = 'Images/main_ico/' + this.main_menu[i] + '.png';
}

Menu.ActiveIco = function(i)
{
	byID('ms' + i).src = 'Images/main_ico/' + this.main_menu[i] + '_sel.png';
}

Menu.updateDate = function()
{
	var d = new Date();	
	widgetAPI.putInnerHTML(byID("mtd1"), this.days[d.getDay()] + "<br/>" + d.getDate() + " " + this.month[d.getMonth()]);
}

Menu.Init = function()
{
	
	for (var i = 0; i < this.main_menu.length; i++)
		Menu.DeactiveIco(i);		
		
	Menu.ActiveIco(0);
	byID("main").style.display = "block";
	Menu.updateDate();
	timer.Init('mtd2');
}


Menu.KeyLeft = function()
{
	if (this.main_menu_id > 0)
	{
		Menu.DeactiveIco(this.main_menu_id);		
		this.main_menu_id--;
		Menu.ActiveIco(this.main_menu_id);		
	}		
}

Menu.KeyUp = function()
{
	if ( (this.main_menu_id - 3) > 0)
	{
		Menu.DeactiveIco(this.main_menu_id);		
		this.main_menu_id -= 4;
		Menu.ActiveIco(this.main_menu_id);		
	}		
}

Menu.KeyDown = function()
{
	if ( (this.main_menu_id + 4) < this.main_menu.length )
	{
		Menu.DeactiveIco(this.main_menu_id);		
		this.main_menu_id += 4;
		Menu.ActiveIco(this.main_menu_id);		
	}
}

Menu.KeyRight = function()
{
	if (this.main_menu_id < (this.main_menu.length - 1))
	{
		Menu.DeactiveIco(this.main_menu_id);		
		this.main_menu_id++;
		Menu.ActiveIco(this.main_menu_id);		
	}		
}

Menu.KeyEnter = function()
{

	Main.ChangeScreen(this.main_menu[this.main_menu_id]);
	switch (Main.screen)
	{	
		case "tv":
			TV.Init();
			break;
		case "epgshort":		
			EpgShort.Init();
			break;
		case "vod":
			break;			
		case "settings":
			break;		
		case "info":
			break;
		case "help":
			break;				
		case "exit":
			widgetAPI.sendReturnEvent();
			break;	
	}
	if (Main.screen != "exit")
		byID(Main.screen).style.display = "block";
}


Menu.MainKeyHandler = function()
{
	var keyCode = event.keyCode;
		
	switch(keyCode)
	{
		case tvKey.KEY_LEFT :
			Menu.KeyLeft();
			break;
		case tvKey.KEY_RIGHT :
			Menu.KeyRight();
			break;
		case tvKey.KEY_UP :
			Menu.KeyUp();
			break;
		case tvKey.KEY_DOWN :
			Menu.KeyDown();
			break;
		case tvKey.KEY_ENTER :
			Menu.KeyEnter();
			break;
        case tvKey.KEY_RETURN:			
			widgetAPI.blockNavigation(event);
			if (!Player.stopped)
				Main.ChangeScreen("player");
		break;		
		default :
			break;
	}
	
}