var TV = {
	target : "main",	
	ch_num : 0,
	ch_page : 0,
	ch_id : 0,
	ch_on_page : 10,
	ch_list : [],
	playing_id : 0,
	day : 0,	
	programs_count : 0,
	info : null,
	porn_access : false,
}

TV.Init = function()
{
	TV.updateChannelList();
}

TV.deInit = function()
{
	Main.BackToMain();
}

TV.GetChannelList = function()
{
		
	var programs = Main.SinGetRequest("channel_list.php?ignoreGmt=y&have_sepg=1");
	var num = 1;
	
	this.ch_list = new Array;
	
	if (programs.hasOwnProperty('groups'))
	{
		
		Epg.channel = programs.groups[0].channels[0];
		for (var i = 0; i < programs.groups.length; i++)
			for (var j = 0; j < programs.groups[i].channels.length; j++)
			{
				var temp = '00' + num;								
				programs.groups[i].channels[j].num = temp.substr(-3,3);
				this.ch_list.push(programs.groups[i].channels[j]);
				num++;
			}
		
		this.programs_count = this.ch_list.length;
		
	}else{
		Main.ERROR_EXIT('GetChannelList');
	}
	
}

TV.updateChannelList = function()
{
	var j = 0;
	var temp_pr_name = '';
	var temp_ch_name = '';
	
	for (var i = 0; i < this.ch_on_page; i++)
	{
		j = i + this.ch_page*this.ch_on_page;
		byID("tv_ch_name" + i).className = "";
		byID("tv_ch_img" + i).src = '';
		widgetAPI.putInnerHTML(byID("tv_ch_name" + i), '');
		widgetAPI.putInnerHTML(byID("tv_ch_pr" + i), '');
		
		if (j < this.ch_list.length)
		{
			if (this.ch_list[j].epg_progname == null) this.ch_list[j].epg_progname = "нет данных";		
			temp_ch_name = (this.ch_list[j].name.length > 20) ? this.ch_list[j].name.substr(0,17) + '...' : this.ch_list[j].name;
			
			temp_pr_name = this.ch_list[j].epg_progname;

			if (temp_pr_name.length > 36)
				temp_pr_name = temp_pr_name.substr(0,36) + '...' ;
				
			byID("tv_ch_img" + i).src = Main.baseImgURL + this.ch_list[j].logo_big;
			widgetAPI.putInnerHTML(byID("tv_ch_name" + i), this.ch_list[j].num + '.' + temp_ch_name);
			widgetAPI.putInnerHTML(byID("tv_ch_pr" + i), this.ch_list[j].t_start + ' ' + temp_pr_name);			
		}
	}	
	TV.MainSetActiveCh();
}

TV.MainSetActiveCh = function()
{
	var i = TV.getChId();
	
	var temp_ch_name = this.ch_list[i].name;
		
	var tv_cur_prog = this.ch_list[i].epg_progname;
	if (tv_cur_prog.length > 60)
		tv_cur_prog = tv_cur_prog.substr(0,60) + '...' ;			
	
	
	byID("atv_ch_img").src = Main.baseImgURL + this.ch_list[i].logo_big;
	widgetAPI.putInnerHTML(byID("atv_ch_name"), this.ch_list[i].num + '.' + this.ch_list[i].name);
	//widgetAPI.putInnerHTML(byID("atv_time"), 	this.ch_list[i].t_start);
	widgetAPI.putInnerHTML(byID("tv_t_start"), 	this.ch_list[i].t_start);
	widgetAPI.putInnerHTML(byID("tv_t_end"), 	this.ch_list[i].t_end);	
	byID("tv_cur_prog").innerHTML = tv_cur_prog;
	byID("tv_ch_name" + this.ch_num).className = "active";
	byID("tv_progress_bar").style.width = getProgressWidth(this.ch_list[i].epg_start, this.ch_list[i].epg_end, Main.servertime) + '%';
	
	
}

TV.MainSetDeactiveCh = function()
{
	byID('tv_ch_name' + this.ch_num).className = '';
}

TV.showInfo = function()
{
	if (this.info != null)
		clearInterval(this.info);

	byID("tv").style.display = "show";
	this.info = setInterval( function(){byID("tv").style.display = "none";}, 3000);
}

TV.SetStatusBar = function()
{
	var	tv_cur_progname = this.ch_list[this.ch_id].epg_progname;
	tv_cur_progname = (tv_cur_progname.length > 60) ? tv_cur_prog.substr(0,60) + '...' : tv_cur_progname;
	widgetAPI.putInnerHTML(byID("status-tv-name"), this.ch_list[this.ch_id].num + '.' + this.ch_list[this.ch_id].name);
	widgetAPI.putInnerHTML(byID("status-tv-desc"), tv_cur_progname);
	widgetAPI.putInnerHTML(byID("status-tv-time-s"), this.ch_list[this.ch_id].t_start);
	widgetAPI.putInnerHTML(byID("status-tv-time-f"), this.ch_list[this.ch_id].t_end);
	
	alert(this.ch_list[this.ch_id].t_end);
	byID("status-tv-img").src = Main.baseImgURL + this.ch_list[this.ch_id].logo_big;

}


TV.getChId = function(){ return (this.ch_num + this.ch_page*this.ch_on_page);}

TV.KeyDown = function()
{
	var i = TV.getChId();
	TV.MainSetDeactiveCh();
	if ( i == (this.ch_list.length - 1))
	{
		this.ch_num = 0;
		this.ch_page = 0; 
		TV.updateChannelList();
		
	}else{
		if ( ((i + 1) % this.ch_on_page) == 0 )
		{
			this.ch_num = 0;
			this.ch_page++;
			TV.updateChannelList();
		}else{
			this.ch_num++;
			TV.MainSetActiveCh();
		}
	}
}

TV.KeyUp = function()
{
	var i = TV.getChId();
	byID('tv_ch_name' + this.ch_num).className = '';
	
	if ( this.ch_num > 0)
	{
		this.ch_num--;
		TV.MainSetActiveCh();
	}else{
		if (i == 0)
		{			
			this.ch_num = (this.programs_count - 1) % this.ch_on_page; 
			this.ch_page = (this.programs_count - this.ch_num - 1) / this.ch_on_page;
		}else{
			this.ch_num = this.ch_on_page - 1;
			this.ch_page--;
		}
		
		TV.updateChannelList();
	}
}

TV.KeyLeft = function()
{
	var i = TV.getChId();
	byID('tv_ch_name' + this.ch_num).className = '';
	
	if ( (i - this.ch_on_page) < 0 )
	{
		this.ch_num = (this.programs_count - 1) % this.ch_on_page;		
		this.ch_page = (this.programs_count - this.ch_num - 1) / this.ch_on_page;
	}else{
		this.ch_page--;
	}
	TV.updateChannelList();
}

TV.KeyRight = function()
{
	var i = TV.getChId();
	byID('tv_ch_name' + this.ch_num).className = '';
	if ( (i + this.ch_on_page) > (this.programs_count - 1) )
	{
		if ( (this.ch_page+1)*this.ch_on_page > (this.programs_count - 1) )
		{
			this.ch_page = 0;
			this.ch_num = 0;
		}else{
			this.ch_page++;
			this.ch_num = (this.programs_count - 1) % this.ch_on_page;
		}
	}else{
		this.ch_page++;
	}
	
	TV.updateChannelList();
}

TV.PlayChannel = function()
{
	/*
	var url = Main.SinGetRequest("get_url.php?&cid=" + this.ch_list[this.ch_id].id);

	try
	{
		Main.ChangeScreen("player");	
		var temp_url = url.url.replace('http/ts://', 'http://');
		var i = temp_url.indexOf(' ');			
		Player.url = (i >= 0) ? temp_url.substr(0, i) : temp_url;		
		Player.Play("live");
		Player.stopped = false;
		this.playing_id = this.ch_id;
		TV.SetStatusBar();
	}catch(e){
		alert(e);
	}
	*/
	Main.ChangeScreen("player");
	alert("ChangeScreen Player");	
	this.ch_id = TV.getChId();

	var pin_check = (this.ch_list[this.ch_id].protected == 0) ? "" : "&protect_code=" + Main.pin;	
	
	try
	{
		var url = Main.SinGetRequest("get_url.php?&cid=" + this.ch_list[this.ch_id].id + pin_check);
		if ( url.url != "protected")
		{
			var temp_url = url.url.replace('http/ts://', 'http://');
			var i = temp_url.indexOf(' ');			
			Player.url = (i >= 0) ? temp_url.substr(0, i) : temp_url;			
			Player.Play("live");					
			this.playing_id = this.ch_id;
			TV.SetStatusBar();
		}else{
			Player.Stop();	
			this.target = "pin";
			Main.screen = "tv";
			byID("pin-main-div").style.display = "block";
		}
		
	}catch(e){
		alert(e);
	}	
}

TV.PlayNextChannel = function()
{
	
	if (Player.state == "live")
	{
		Player.Stop();
		
		this.ch_id = TV.getChId();
		this.ch_id++;
		
		if ( this.ch_id < this.programs_count)
		{
			this.ch_num++;
			if (this.ch_num == this.ch_on_page)
			
			this.ch_num++;
			this.ch_num = (this.ch_num < this.ch_on_page) ? this.ch_num : 0;
		}else{
			this.ch_num = 0;
			this.ch_page = 0;
		}
		this.ch_id = TV.getChId();
		TV.PlayChannel();		
		
	}

}

TV.PlayPrevChannel = function()
{

	if (Player.state == "live")
	{
		Player.Stop();
		
		this.ch_id = TV.getChId();
		this.ch_id--;
		
		if ( this.ch_num == 0)
		{
			if (this.ch_page == 0)
			{
				this.ch_num = (this.programs_count - 1) % this.ch_on_page; 
				this.ch_page = (this.programs_count - this.ch_num - 1) / this.ch_on_page;			
			}else{			
				this.ch_num = this.ch_on_page - 1;
				this.ch_page--;
			}
		}else{
			this.ch_num--;			
		}
		this.ch_id = TV.getChId();		
		TV.PlayChannel();
	}
}

TV.InputPin = function()
{
	var num = Main.Key10Down();
	if (num >= 0)
		byID("tvpin").value += num;
}

TV.CheckPin = function()
{
	if (byID("tvpin").value == Main.pin)
	{
		byID("pinclose").style.display = "none";
		this.target = "main";
		this.porn_access = true;		
		TV.PlayChannel();	
	}else{
		byID("tvpin").value = "";
		byID("pinerror").style.display = "block";
		setTimeout('byID("pinerror").style.display = "none";', 2000);
	}
}

TV.MainKeyHandler = function()
{
	var keyCode = event.keyCode;
	


	switch (this.target)
	{
		case "pin":
			switch(keyCode)
			{
				case tvKey.KEY_PRECH:
					var t = byID("tvpin").value;
					if( t.length > 0 ) byID("tvpin").value = t.substr(0, t.length - 1);
					break;	
					
				case tvKey.KEY_RETURN:			
					widgetAPI.blockNavigation(event);
					byID("pinclose").style.display = "none";
					this.target = "main";
					break;						
				
				case tvKey.KEY_ENTER :	
					TV.CheckPin();
					break;
					
				default :
					TV.InputPin();
					break;
				
			}
			break;
		default:
			switch(keyCode)
			{
				case tvKey.KEY_LEFT :
					TV.KeyLeft();
					break;
				case tvKey.KEY_RIGHT :
					TV.KeyRight();
					break;
				case tvKey.KEY_UP :
					TV.KeyUp();
					break;
				case tvKey.KEY_DOWN :
					TV.KeyDown();
					break;
				case tvKey.KEY_RED :
					//Epg.channel = this.ch_list[TV.getChId()];
					//Epg.Init();			
					EpgShort.Init();
					Main.ChangeScreen("epgshort");
					break;	
				case tvKey.KEY_YELLOW:						
					Main.ChangeScreen("vod");
					break;				
				case tvKey.KEY_RETURN:			
					widgetAPI.blockNavigation(event);
					Player.stopped ? Main.ChangeScreen("main") : Main.ChangeScreen("player");
				break;					
				case tvKey.KEY_ENTER :		
					
					this.ch_id = TV.getChId();
					if ((this.ch_id == -1) && !this.porn_access)
					{
						this.target = "pin";
						byID("pinclose").style.display = "block";
						byID("tvpin").focus();
						
					}else{
						Main.ChangeScreen("player");
						
						if ( (this.playing_id != this.ch_id) || (Player.state != "live") )													
							TV.PlayChannel();				
					}					
					break;
		}
	}
}