var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var pluginAPI = new Common.API.Plugin();

var Main = 
{
	screen : "main",
	backscreen : "main",
	auth : false,
	XHRObj : null,
	baseReqURL : "http://93.189.144.156:8501/api/json/",
	baseImgURL : "http://93.189.144.156:8501/_logos/channelLogos/",
	baseReqURL : "http://iptv.new-rus.tv:8501/api/json/",
	baseImgURL : "http://iptv.new-rus.tv:8501/_logos/channelLogos/",
	sid : '',
	sid_name : '',
	login : '1111',
	pass : '1111',
	servertime : 0,
	curtime : 0,
	timeshift : 0,
	buffer : 6,
	background : "Images/background.png",
	infoban : null,
	pin : "",
	configFile : "newrus2dd1f.dat",
	pin_check : false,
}

Main.onLoad = function()
{
	//pluginAPI.unregistKey(tvKey.KEY_MENU);
	window.onshow = function(){		 // register function will be run onshow event
			pluginAPI.registKey(tvKey.KEY_MENU);
			Main.UnRegisterKey();
	}	
	jQuery.support.cors = true;
	
	Main.GetConfig();
	
	if (Main.Auth())
	{
		alert(this.sid_name + ' : ' + this.sid);
		this.pin = this.pass;
		Main.Init();
		// for timeshift values other then 0 streaming does not work
		// fo thsi will fix any streamming issues related to this
		Settings.SetNewValues("timeshift", 0);
	}else{
		Main.ChangeScreen("auth");
		Auth.Init();
	}
	
	widgetAPI.sendReadyEvent();	
}

Main.onUnload = function()
{
	Player.Deinit();	
}

Main.Init = function()
{
	this.pin = this.pass;
	widgetAPI.blockNavigation(event);	
	Menu.Init();
	Player.Init();
	Vod.Init();
	Info.Init();
	TV.GetChannelList();
	Audio.Init();
	Settings.Init();
	byID("minfo").style.display = "table";
	
}

Main.UnRegisterKey = function()
{
	pluginAPI.registKey(KEY_TOOLS);
	pluginAPI.registKey(KEY_EMODE);
	pluginAPI.registKey(KEY_DMA);
	pluginAPI.registKey(KEY_SOURCE);
	pluginAPI.registKey(KEY_FAVCH);
	pluginAPI.registKey(KEY_CHLIST);
	pluginAPI.registKey(KEY_DMA);
	pluginAPI.registKey(KEY_TTX_MIX);
	pluginAPI.registKey(KEY_GUIDE);
	pluginAPI.registKey(KEY_SUBTITLE);
	pluginAPI.registKey(KEY_ASPECT);
	pluginAPI.registKey(KEY_DOLBY_SRR);
	pluginAPI.registKey(KEY_MTS);
}

Main.ERROR_EXIT = function(str)
{
	alert('ERROR : ' + str);
}

function parser(str, left) { 
       var res = '';
       var tmp = str; 
       var i = tmp.indexOf(left);
        if ( i > 0 )   {
            tmp = tmp.substr(i -1 + left.length);
        }
		alert("PARSER");
		alert(tmp);
    return tmp;    
}

Main.AsinGetRequest = function(callbackfunc, URL)
{
	if ( (this.sid_name != '') && (this.sid != '') )
		URL = URL + '&' + this.sid_name + '=' + this.sid;
		
	if (this.XHRObj != null)
		this.XHRObj.destroy();
	this.XHRObj = new XMLHttpRequest();
	alert(this.baseReqURL + URL);	
	if (this.XHRObj) {
		this.XHRObj.open("GET", this.baseReqURL + URL, true);
		this.XHRObj.onreadystatechange = function () {		
			if (Main.XHRObj.readyState == 4) {
				if(Main.XHRObj.status == 200) {
				Main.XHRObj.responseText = parser(Main.XHRObj.responseText, "{")
					callbackfunc(Main.XHRObj.responseText);					
				}
			}
		};		
		this.XHRObj.send(null);
	}
}

Main.CheckTime = function(str)
{
	var d = new Date;
	alert(str + ' : ' + d.getTime());
}

Main.SinGetRequest = function(URL)
{

	alert("11111111dddddddddddddddddddddd");
	alert(this.baseReqURL + URL);	
	var d = new Date();
	
	if ( (this.sid_name != '') && (this.sid != '') )
		URL = URL + '&' + this.sid_name + '=' + this.sid;
	Main.CheckTime("NEW REQUEST");		
	
	if (this.XHRObj != null)
		this.XHRObj.destroy();
	this.XHRObj = new XMLHttpRequest();
	
	if (this.XHRObj) {
		
		this.XHRObj.open("GET", this.baseReqURL + URL, false);
		this.XHRObj.send(null);
		var test = parser(this.XHRObj.responseText, "{")

		alert(URL + ' : ' + this.XHRObj.responseText);
		alert("HHHHHHHHHHHHHHHHHHHHH");
		alert(test);
		
		var err = {"error" : "Error in response"}; 
		if (this.XHRObj.responseText != "") {
			try {				
				var temp = eval('(' + test + ')');
				return temp;		
			}catch (e){
				
				alert(e);
				alert(this.XHRObj.responseText);
				Main.ShowError(e);			
				return err;
			}	
		}else{
			return err;
		}

	}
	
	return '';
}

Main.GetConfig = function()
{
	
	var setupArray=new Array();
	var fileSystemObj = new FileSystem();
	
	var oFile=fileSystemObj.openCommonFile(this.configFile, "r");
		
	if (oFile)
	{
		while(1)
		{
			l= oFile.readLine();
			if (l==null) 
				break;
			setupArray.push(l);
		 }
		fileSystemObj.closeCommonFile(oFile);
		
		if (setupArray.length > 1)
		{
			this.login = setupArray[0];
			this.pass = setupArray[1];
			
//			if (setupArray.length > 2)				
//				this.timeshift = isNaN(parseInt(setupArray[2])) ? 3 : parseInt(setupArray[2]);
				
			
			if (setupArray.length > 3)
				this.buffer = isNaN(parseInt(setupArray[3])) ? 8 : parseInt(setupArray[3]);
			
		}else{
			this.login = '';
			this.pass = '';
		}
	}
	
	alert (this.login + " = " + this.pass);
}

Main.WriteNewConfig = function()
{
	alert('WriteNewConfig');
	var fileSystemObj = new FileSystem();
    var oFile = fileSystemObj.openCommonFile( this.configFile, "w");
	
    oFile. writeLine(this.login);
	oFile. writeLine(this.pass);
	oFile. writeLine(this.timeshift+'');	
	oFile. writeLine(this.buffer+'');
	
    fileSystemObj.closeCommonFile(oFile);
}
Main.DeleteConfig = function()
{
    alert('DeleteConfig');
     var fileSystemObj = new FileSystem();
     var bResult = fileSystemObj.deleteCommonFile(this.configFile);
     alert("ddd"+bResult);
}

Main.Auth = function()
{
	
	var req = Main.SinGetRequest("login.php?login=" + this.login + "&pass=" + this.pass);

	if (req != '')
	{
		if (req.hasOwnProperty("error"))
		{
			return false;
		}else{
			this.sid = req.sid;
			this.sid_name = req.sid_name;
			this.servertime = req.servertime;			
			return true;
		}
		return true;
	}else{
		return false;
	}
}


Main.ChangeScreen = function(a)
{
	this.backscreen = this.screen;
	byID(this.screen).style.display = "none";
	this.screen = a;
	byID(this.screen).style.display = "block";
}

Main.HideScreenBackground = function()
{
	byID("body").style.backgroundImage = "";
}

Main.ShowScreenBackground = function()
{
	byID("body").style.backgroundImage = 'url("' + this.background +'")';
}

Main.ShowError = function(str)
{

	byID(this.screen).style.display = "none";
	byID("errStr").innerHTML = str;
	byID("err").style.display = "block";
	setTimeout(Main.onUnload, 1000);
}

Main.ShowInfo = function(msg, timeout)
{

	byID("infoban").style.display = "block";
	byID("infoban").innerHTML = msg;
	if (timeout > 0)
	{
		if (this.infoban != null)
			clearTimeout(this.infoban);
		this.infoban = setTimeout(Main.CloseInfo, timeout);
	}
}

Main.CloseInfo = function()
{
	byID("infoban").style.display = "none";
}

Main.Key10Down = function()
{
	var keyCode = event.keyCode;
	switch(keyCode)
	{
        case tvKey.KEY_1: return 1; break;
		case tvKey.KEY_2: return 2; break;
		case tvKey.KEY_3: return 3; break;
		case tvKey.KEY_4: return 4; break;
		case tvKey.KEY_5: return 5; break;
		case tvKey.KEY_6: return 6; break;
		case tvKey.KEY_7: return 7; break;
		case tvKey.KEY_8: return 8; break;
		case tvKey.KEY_9: return 9; break;
		case tvKey.KEY_0: return 0; break;
		default: return -1; break;
	}
}

Main.KeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
        case tvKey.KEY_VOL_UP:        
            alert("VOL_UP");
            Audio.setRelativeVolume(0);
            break;
            
        case tvKey.KEY_VOL_DOWN:        
            alert("VOL_DOWN");
            Audio.setRelativeVolume(1);
            break;      
        
        case tvKey.KEY_MUTE:
            alert("MUTE");
            Audio.muteMode();
            break;        
			
		case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);					
			(this.screen == "main") ? widgetAPI.sendReturnEvent() : Main.ChangeScreen("main");
            break;
		case tvKey.KEY_MENU:
			widgetAPI.blockNavigation(event);
			if (this.screen != "auth")
				Main.ChangeScreen("main");
			break;
		default:	
			switch (this.screen)
			{
				case "main":
					Menu.MainKeyHandler();
					break;
				case "tv":
					TV.MainKeyHandler();
					break;			
				case "epg":
					Epg.MainKeyHandler();
					break;
				case "epgshort":	
					EpgShort.MainKeyHandler();
					break;
				case "vod":
					Vod.MainKeyHandler();
					break;			
				case "settings":
					Settings.MainKeyHandler();
					break;		
				case "info":
					Info.MainKeyHandler();
					break;
				case "help":
					Help.MainKeyHandler();
					break;				
				case "player":
					Player.MainKeyHandler();
					break;				
				case "movie":
					Movie.MainKeyHandler();
					break;				
				case "auth":
					Auth.MainKeyHandler();
					break;							
			}
			break;
		}
}
