var Settings = {
	menu : 	[
//				{code : "time",			title : "Часовой пояс"},
				{code : "buffer",		title : "Буферизация"},
				{code : "pin",			title : "Смена пин-кода"},
				{code : "sort",			title : "Сортировка каналов"},	
                {code : "exit",			title : "Сброс настроек"},
			],
	menu_item : 0,		
	screen : "main",
	setside : "left",
	sort_on_page : 0,
	sort_page : 0,
	sort_num : 0,
	sort_list : [],
	buffer : 0,
	timeshift : 0,
	pin_target : 0,	
}

Settings.GetMenuItemCode = function(){ return this.menu[this.menu_item].code;}
Settings.GetMenuItemTitle = function(){ return this.menu[this.menu_item].title;}

Settings.Init = function()
{
	this.buffer = Main.buffer;
	this.timeshift = Main.timeshift;
	
	Settings.MainMenuOut();	
//	Settings.UpdateTime();	
	Settings.UpdateBuffer();	
}

Settings.SetNewValues = function( setvar, setval )
{
	var answ = Main.SinGetRequest("settings_set.php?&var=" + setvar + "&val=" + setval);
	try {
		if (answ.message.code == "4")
		{
			alert("It's ok!");
			Main.WriteNewConfig();
		}
	} catch (e) {
		alert (e);
	}
}

Settings.SetActiveMenuItem = function(){byID("set-" + this.menu_item).className = "active";}
Settings.SetDeactiveMenuItem = function(){byID("set-" + this.menu_item).className = "";}

Settings.MainMenuOut = function()
{
	for (var i = 0; i < this.menu.length; i++)
		byID("set-" + i).innerHTML = this.menu[i].title;
	Settings.SetActiveMenuItem();
}

Settings.InitSubScreen = function()
{
	this.setside = "left";
	byID(this.screen + "-left-set").src = "/Images/settings/left_sel.png";
	byID(this.screen + "-right-set").src = "/Images/settings/right.png";
}

Settings.ChangeSetSide = function()
{
	if (this.setside == "left")
	{
		this.setside = "right";
		byID(this.screen + "-left-set").src = "/Images/settings/left.png";
		byID(this.screen + "-right-set").src = "/Images/settings/right_sel.png";
	}else{
		this.setside = "left";
		byID(this.screen + "-left-set").src = "/Images/settings/left_sel.png";
		byID(this.screen + "-right-set").src = "/Images/settings/right.png";		
	}
}


Settings.MainMenuKeyDown = function()
{
	if (this.menu_item < (this.menu.length-1))
	{
		Settings.SetDeactiveMenuItem();
		this.menu_item++;
		Settings.SetActiveMenuItem();
	}
}

Settings.MainMenuKeyUp = function()
{
	if (this.menu_item > 0)
	{
		Settings.SetDeactiveMenuItem();
		this.menu_item--;
		Settings.SetActiveMenuItem();
	}
}


Settings.ChangeScreen = function(str)
{	
    if (str == "exit")
        Settings.MakeClear();
	if (str == "pin")	Settings.InitPin();
	   byID("settings-" + this.screen).style.display = "none";	
	this.screen = str;
	
	if ( (str == "buffer") || (str == "time") ) Settings.InitSubScreen();
    if (str != "exit")
        byID("settings-" + this.screen).style.display = "block";
	
}

Settings.MainKeyHandler = function()
{
	switch (this.screen)
	{
		case "main":
			Settings.MainMenuKeyHandler();
			break;	
		case "time":
			Settings.TimeKeyHandler();
			break;
		case "buffer":
			Settings.BufferKeyHandler();
			break;
		case "pin":			
			Settings.PinKeyHandler();
			break;
		case "sort":
			Settings.SortKeyHandler();
			break;		
	}
}

/* MainMenu */

Settings.MainMenuKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
        case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			Main.ChangeScreen("main");
		break;
        case tvKey.KEY_DOWN:
			Settings.MainMenuKeyDown();
		break;		
        case tvKey.KEY_UP:
			Settings.MainMenuKeyUp();
		break;			
        case tvKey.KEY_ENTER:
			Settings.ChangeScreen(Settings.GetMenuItemCode());
		break;			
	}
}


/* Time */

Settings.TimeKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
        case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			if (this.timeshift != Main.timeshift)
			{
				Settings.SetNewValues("timeshift", Main.timeshift);
				alert("New Values");
			}
			Settings.ChangeScreen("main");
		break;
        case tvKey.KEY_LEFT:
			if (this.setside != "left") Settings.ChangeSetSide();
		break;		
        case tvKey.KEY_RIGHT:
			if (this.setside != "right") Settings.ChangeSetSide();
		break;				
        case tvKey.KEY_ENTER:
			Settings.TimeChangeVal();
		break;						
	}
}

Settings.TimeChangeVal = function()
{
	if (this.setside == "left")
		if (Main.timeshift > -12)
		{
			Main.timeshift--;
			Settings.UpdateTime();
		}
		
	if (this.setside == "right")
		if (Main.timeshift < 12)
		{
			Main.timeshift++;
			Settings.UpdateTime();
		}		
}

Settings.UpdateTime = function()
{
	byID("time-val").innerHTML = Main.timeshift;
}

/* Buffer */

Settings.BufferKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
        case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			Main.WriteNewConfig();
			Settings.ChangeScreen("main");
		break;
        case tvKey.KEY_LEFT:
			if (this.setside != "left") Settings.ChangeSetSide();
		break;		
        case tvKey.KEY_RIGHT:
			if (this.setside != "right") Settings.ChangeSetSide();
		break;				
        case tvKey.KEY_ENTER:
			Settings.BufferChangeVal();
		break;						
	}
}

Settings.BufferChangeVal = function()
{
	if (this.setside == "left")
		if (Main.buffer > 4)
		{
			Main.buffer--;
			Settings.UpdateBuffer();
		}
		
	if (this.setside == "right")
		if (Main.buffer < 30)
		{
			Main.buffer++;
			Settings.UpdateBuffer();
		}		
}

Settings.UpdateBuffer = function()
{
	byID("buffer-val").innerHTML = Main.buffer;
}
/* Pin */

Settings.PinKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
		case tvKey.KEY_DOWN:
			if (this.pin_target < 3) this.pin_target++;			
			break;
		case tvKey.KEY_UP:
			if (this.pin_target > 0) this.pin_target--;			
			break;							
		case tvKey.KEY_ENTER:
			Settings.SavePin();
			break;
        case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			Settings.ChangeScreen("main");
		break;
		case tvKey.KEY_PRECH:
			var t = byID("pin"+this.pin_target).value;
			if( t.length > 0 ) byID("pin"+this.pin_target).value = t.substr(0, t.length - 1);
		break;
		default:
			Settings.InputPin();
		break;
	}
}

Settings.InputPin = function()
{
	var num = Main.Key10Down();
	if (num >= 0)
		byID("pin" + this.pin_target).value += num;	
	
}

Settings.SavePin = function()
{
	var itsallright = true;
	for (var i = 0; i < 3; i++)	
		if (byID("pin" + i).value == "")
		{
			itsallright = false;
			this.pin_target = i;
			break;
		}
	itsallright = itsallright && (byID("pin2").value == byID("pin1").value);	
	
	
	if (itsallright)
	{
		//Main.SinGetRequest("settings_set.php?var=pcode&old_code=" + byID("pin0").value + "&new_code=" + byID("pin1").value + "&confirm_code=" +  byID("pin2").value ;
		alert("New pin: " + byID("pin1").value);
		Main.pin = byID("pin1").value;
		byID("pin-save").innerHTML = "ПИН-код сохранен";
		
	}
	
	return 1;
}

Settings.InitPin = function()
{
	byID("pin0").value = "";
	byID("pin1").value = "";
	byID("pin2").value = "";
	byID("pin-save").innerHTML = "";	
}

/* Sort */

Settings.SortKeyHandler = function()
{
	var keyCode = event.keyCode;
	
	switch(keyCode)
	{
        case tvKey.KEY_RETURN:
			widgetAPI.blockNavigation(event);
			Settings.ChangeScreen("main");
		break;
	}
}

Settings.SortInit = function()
{

}

Settings.MakeSortList = function()
{

}

Settings.MakeClear = function()
{
     alert("wwwww");
      Main.login = "";
      Main.pass = "";
      Main.DeleteConfig();
	  Main.ChangeScreen("auth");
      Auth.Init();
}
